import type { BuildInPlacements, TriggerProps } from '@rc-component/trigger';
import type { CSSProperties, FC } from 'react';
import React from 'react';
import { TriggerPlacement, TriggerType } from './interface';
import type { PanelProps } from './Panel';
export interface ColorPickerProps extends PanelProps {
    open?: boolean;
    trigger?: TriggerType;
    children: React.ReactElement;
    disabled?: boolean;
    onOpenChange?: (open: boolean) => void;
    /** Popup placement */
    placement?: TriggerPlacement;
    getPopupContainer?: (node: HTMLElement) => HTMLElement;
    classNames?: {
        popup?: string;
    };
    styles?: {
        popup?: CSSProperties;
    };
    builtinPlacements?: BuildInPlacements;
    arrow?: boolean;
    motion?: TriggerProps['popupMotion'];
}
declare const ColorPicker: FC<ColorPickerProps>;
export default ColorPicker;
